Loading...
Searching...
No Matches
QXmppRpcManager Class Reference
Managers

The QXmppRpcManager class make it possible to invoke remote methods and to expose local interfaces for remote procedure calls, as specified by XEP-0009: Jabber-RPC. More...

`#include <QXmppRpcManager.h>`

Inheritance diagram for QXmppRpcManager:
[legend]
Collaboration diagram for QXmppRpcManager:
[legend]

## Public Member Functions

| QXmppRpcManager ()
| Constructs a QXmppRpcManager.
void | addInvokableInterface (QXmppInvokable *interface)

QXmppRemoteMethodResult

callRemoteMethod (const QString &jid, const QString &interface, const QVariant &arg1=QVariant(), const QVariant &arg2=QVariant(), const QVariant &arg3=QVariant(), const QVariant &arg4=QVariant(), const QVariant &arg5=QVariant(), const QVariant &arg6=QVariant(), const QVariant &arg7=QVariant(), const QVariant &arg8=QVariant(), const QVariant &arg9=QVariant(), const QVariant &arg10=QVariant())

Public Member Functions inherited from QXmppClientExtension
| QXmppClientExtension ()
virtual QStringList | discoveryFeatures () const
virtual QList< QXmppDiscoveryIq::Identity > | discoveryIdentities () const
virtual bool | handleStanza (const QDomElement &stanza)
| You need to implement this method to process incoming XMPP stanzas.
virtual bool | handleStanza (const QDomElement &stanza, const std::optional< QXmppE2eeMetadata > &e2eeMetadata)
| You need to implement this method to process incoming XMPP stanzas.
Public Member Functions inherited from QXmppLoggable
| QXmppLoggable (QObject *parent=nullptr)

## Additional Inherited Members

Signals inherited from QXmppLoggable
void | setGauge (const QString &gauge, double value)
| Sets the given gauge to value.
void | logMessage (QXmppLogger::MessageType type, const QString &msg)
| This signal is emitted to send logging messages.
void | updateCounter (const QString &counter, qint64 amount=1)
| Updates the given counter by amount.
Protected Member Functions inherited from QXmppClientExtension
QXmppClient * | client ()
virtual void | setClient (QXmppClient *client)
void | injectIq (const QDomElement &element, const std::optional< QXmppE2eeMetadata > &e2eeMetadata)
bool | injectMessage (QXmppMessage &&message)
Protected Member Functions inherited from QXmppLoggable
void | debug (const QString &message)
void | info (const QString &message)
void | warning (const QString &message)
void | logReceived (const QString &message)
void | logSent (const QString &message)

## Detailed Description

The QXmppRpcManager class make it possible to invoke remote methods and to expose local interfaces for remote procedure calls, as specified by XEP-0009: Jabber-RPC.

To make use of this manager, you need to instantiate it and load it into the QXmppClient instance as follows:

QXmppRpcManager *manager = new QXmppRpcManager;
client->addExtension(manager);
QXmppClientExtension::client
QXmppClient * client()
Definition QXmppClientExtension.cpp:78
QXmppClient::addExtension
bool addExtension(QXmppClientExtension *extension)
Definition QXmppClient.cpp:259
QXmppRpcManager
The QXmppRpcManager class make it possible to invoke remote methods and to expose local interfaces fo...
Definition QXmppRpcManager.h:36
QXmppRpcManager::QXmppRpcManager
QXmppRpcManager()
Constructs a QXmppRpcManager.
Definition QXmppRpcManager.cpp:15

Note
  THIS API IS NOT FINALIZED YET

## Member Function Documentation

## addInvokableInterface()

void QXmppRpcManager::addInvokableInterface | ( | QXmppInvokable * | interface | ) |

Adds a local interface which can be queried using RPC.

Parameters

  interface |

## callRemoteMethod()

QXmppRemoteMethodResult QXmppRpcManager::callRemoteMethod | ( | const QString & | jid,
|  | const QString & | interface,
|  | const QVariant & | arg1 = `QVariant()`,
|  | const QVariant & | arg2 = `QVariant()`,
|  | const QVariant & | arg3 = `QVariant()`,
|  | const QVariant & | arg4 = `QVariant()`,
|  | const QVariant & | arg5 = `QVariant()`,
|  | const QVariant & | arg6 = `QVariant()`,
|  | const QVariant & | arg7 = `QVariant()`,
|  | const QVariant & | arg8 = `QVariant()`,
|  | const QVariant & | arg9 = `QVariant()`,
|  | const QVariant & | arg10 = `QVariant()`
| ) |  |

Calls a remote method using RPC with the specified arguments.

Note
  This method blocks until the response is received, and it may cause XMPP stanzas to be lost!

The documentation for this class was generated from the following files:

- QXmppRpcManager.h
- QXmppRpcManager.cpp